<template>
  <form
    class="p-2 flex flex-col justify-center gap-2 w-96"
    @submit.prevent.stop="createHindrance"
  >
    <BaseTextArea
      v-model="description"
      class="w-full"
      rows="4"
      placeholder="Descrição..."
      required
    />
    <div class="flex flex-row justify-between gap-2 items-center">
      <div class="flex flex-col gap-2">
        <div class="flex flex-row justify-start gap-2 items-center">
          <label for="select">Projeto</label>
          <BaseSelectInput
            id="select"
            v-model="selectedProject"
            :data="projects"
            required
            class="w-full"
          />
        </div>
        <div class="flex flex-row justify-start gap-2 items-center">
          <label for="select">Categoria</label>
          <BaseSelectInput
            id="select"
            v-model="workCategorie"
            :data="workCategories"
            required
            class="w-full"
          />
        </div>
      </div>
      <div class="flex flex-row justify-center gap-2 items-center">
        <label for="publicHindrance">Publico</label>
        <input
          id="publicHindrance"
          v-model="publicHindrance"
          class="h-4 w-4 bg-primary-200 rounded border border-primary-500 text-primary-700"
          type="checkbox"
        />
      </div>
    </div>
    <div class="flex flex-row justify-center">
      <BaseButton
        type="submit"
        label="Adicionar"
        class="border border-success-300 border-opacity-40 rounded bg-success-300 bg-opacity-20"
      >
        <FolderAddIcon class="h-5 w-5" />
      </BaseButton>
    </div>
  </form>
</template>

<script>
import { FolderAddIcon } from '@vue-hero-icons/outline'
import BaseSelectInput from '../ui/BaseSelectInput.vue'
import BaseTextArea from '../ui/BaseTextArea.vue'
import BaseButton from '../ui/BaseButton.vue'
import { getAxiosHeaders } from '~/utils/utils'
import Hindrance from '~/classes/Hindrance'
export default {
  name: 'CreateHindranceForm',
  components: {
    BaseSelectInput,
    FolderAddIcon,
    BaseTextArea,
    BaseButton,
  },
  data() {
    return {
      description: null,
      selectedProject: null,
      workCategorie: null,
      publicHindrance: false,
    }
  },
  computed: {
    projects() {
      return this.$store.state.projects.list
    },
    workCategories() {
      return this.$store.state.workCategories.list
    },
  },
  methods: {
    createHindrance() {
      try {
        this.$axios
          .$post(
            'addHindrance',
            {
              description: this.description,
              public: this.publicHindrance,
              work_category_id: this.workCategorie,
              project_id: this.selectedProject,
            },
            getAxiosHeaders(this.$auth)
          )
          .then((response) => {
            if (response.status.is_error) {
              return this.$toast.error(
                'Ocorreu um erro ao cadastrar impedimento.',
                {
                  closeOnSwipe: true,
                  duration: 3000,
                }
              )
            }
            this.$store.commit(
              'hindrances/craeteHindrance',
              new Hindrance({
                ...response.data.hindrance,
                isPublic: response.data.hindrance.public,
              })
            )
            this.$toast.success('Impedimento cadastrado!', {
              closeOnSwipe: true,
              duration: 2000,
            })
            this.$emit("close")
          })
      } catch (error) {
        // eslint-disable-next-line no-console
        console.warn(error)
        this.$toast.error('Ocorreu um erro inesperado...', {
          closeOnSwipe: true,
          duration: 2000,
        })
      }
    },
  },
}
</script>
